// 加载数据, 文章预览在用
function loadData(dataStr) {
    var data = JSON.parse(dataStr);
    // labs
    var oldChildren = document.getElementsByClassName("catalogue-label");
    for (var j=oldChildren.length-1;j>=0;j--) {
        oldChildren[j].remove();
    }

    var catalogueBox = document.getElementById("catalogue_box");
    for (var i=0;i<data.tags.length;i++) {
        var oneLabel = data.tags[i];
        var labHtml = "<a onClick='clickLabel(this)' labelId='"+oneLabel.id+"' labelName='"+oneLabel.name+"'  class='catalogue-label'>"+oneLabel.name+"</a>";
        catalogueBox.insertAdjacentHTML('beforeend', labHtml);

    }

    // origin warn
    if (!data.original&&document.getElementById("origin_warn")) {
        document.getElementById("origin_warn").remove();
    }
    // title subtitle time
    document.getElementById("title").innerHTML=data.title;
    document.getElementById("time").innerText=data.create_time;
    document.getElementById("read_count").innerText=(data.view_num+"浏览");
    // userhead nickname
    document.getElementById("author_name").innerText=(data.author.nickname);
    document.getElementById("author_header").src=(data.author.imageUrl);
    document.getElementById("author_header").value=(data.author.id);
    // 等级
    var levelRes = "../img/user_level_1.png";
    switch(data.author.level) {
        case 2:
            levelRes = "../img/user_level_2.png";
            break
        case 3:
            levelRes = "../img/user_level_3.png";
            break
        case 4:
            levelRes = "../img/user_level_4.png";
            break
        case 5:
            levelRes = "../img/user_level_5.png";
            break
        case 6:
            levelRes = "../img/user_level_6.png";
            break
        case 7:
            levelRes = "../img/user_level_7.png";
            break
    }
    document.getElementById("author_level").src=levelRes;
    // 关注
    document.getElementById("focus_state").innerText=(data.author.is_follow?"已关注":"关注");
}

// 文章加载数据,用户看的文章详情在用
function loadContent(content) {
    // content
    document.getElementById("hand_note_content").innerHTML=(content);
    // 优化代码显示,显示出代码预览
    initCodeCopy();

}

function initCodeCopy() {
    $(".cl-preview-section pre").each(function(i,v) {
        var $el = $(v);
        console.log("add code menu")
        $el.append('<span class="code-view">点击代码块进入预览</span><span class="code-copy">复制代码</span>');
    });
    $('.cl-preview-section pre .code-copy').on('click', function() {
        var $cloneEl = $(this).parent('pre').find('code').clone().css({
            'position': 'fixed',
            'left': '10000px'
        });
        $(this).after($cloneEl);
        var text = $cloneEl[0];
        if (document.body.createTextRange) {
            var range = document.body.createTextRange();
            range.moveToElementText(text);
            range.select();
        } else if (window.getSelection) {
            var selection = window.getSelection();
            var range = document.createRange();
            range.selectNodeContents(text);
            selection.removeAllRanges();
            selection.addRange(range);
        } else {
            handNoteDetail.toast("复制失败");
            return false;
        }
        document.execCommand('Copy', 'false', null);
        handNoteDetail.toast("复制成功");
        $cloneEl.remove();
    });
    $('.cl-preview-section pre .code-view,.cl-preview-section code').on('click', function() {
        var content = $(this).parents('.cl-preview-section pre').find('code').html();
        if (content == null) {
            return
        }
        var temp = '<div class="code-view-wrap"><div class="code-view-content"><pre><code>'+content+'</code></pre></div><div class="code-view-bottom"><span>退出预览</span></div></div>';
        var stop = $(window).scrollTop()*-1;
        $(document.body).append(temp).addClass('code-view-body');
        handNoteDetail.stopScroll();
        $(".code-view-body").css('top',stop+"px");
         $('#all_content').hide();
        $(".code-view-bottom span").click(function(){
            $('#all_content').show();
            $(".code-view-wrap").remove();
            handNoteDetail.resumeScroll();
            $(document.body).removeClass('code-view-body');
            $(window).scrollTop(parseInt($(document.body).css('top'))*-1);
        })
    })
}

function pressBack() {
    if ($(".code-view-wrap").length > 0) {
        $('#all_content').show();
        $(".code-view-wrap").remove();
        handNoteDetail.resumeScroll();
        $(document.body).removeClass('code-view-body');
        $(window).scrollTop(parseInt($(document.body).css('top'))*-1);
        return true;
    } else {
        return false;
    }
}

function loadAdvertise(adList) {
    // ads
    var ads = JSON.parse(adList);
    var relativeUl = document.getElementById("relative_ul");
    var oldChild = relativeUl.children;
    for (var j =oldChild.length-1;j>=0;j--) {
        oldChild[j].remove();
        console.log("remove ad j:"+j);
    }

    for (var i=0;i<ads.length;i++) {
        var oneAd = ads[i];
        var adHtml = "<li onClick='clickAD(this)' adId='"+oneAd.id+"' >"+oneAd.name+"</li>";
        relativeUl.insertAdjacentHTML('beforeend', adHtml);

    }


}

function loadRecommendCourse(courseList) {
    var courses = JSON.parse(courseList);
    if (courses == undefined || courses.length==0) {
        document.getElementById("recommend_course_container").style.display="none"
        return
    } else {
        document.getElementById("recommend_course_container").style.display=""
    }
    // courses
    var relativeUl = document.getElementById("relative_course_ul");
    var oldChild = relativeUl.children;
    for (var j =oldChild.length-1;j>=0;j--) {
        oldChild[j].remove();
        console.log("remove courses j:"+j);
    }

    for (var i=0;i<courses.length;i++) {
        var oneCourse = courses[i];

        var htmlStr = [];
        var courseData = "";
        if(oneCourse.map.step > 0){
            /* 路径 */
            courseData = "¥" + oneCourse.map.pay_price + "&nbsp;&nbsp;" + oneCourse.map.step + "步聚·" + oneCourse.map.courses + "门课&nbsp;&nbsp;&nbsp;<img src='./learn_number.png' class='learn_num_icon'>&nbsp;"+oneCourse.map.numbers;
        }else if(oneCourse.map.pay_price != undefined){
            /* 实战 */
            courseData = "¥" + oneCourse.map.pay_price + "&nbsp;&nbsp;" + oneCourse.map.level + "&nbsp;&nbsp;&nbsp;<img src='./learn_number.png' class='learn_num_icon'>&nbsp;"+oneCourse.map.numbers;
        }else{
            /* 免费 */
            courseData = "免费&nbsp;&nbsp;" +  oneCourse.map.level + "&nbsp;&nbsp;&nbsp;<img src='./learn_number.png' class='learn_num_icon'>&nbsp;"+oneCourse.map.numbers;
        }

        /*TODO 样式调整 div中的内容垂直局中 */
        htmlStr.push(
            "<li onClick='clickCourse(this)' typeId='"+oneCourse.type_id+"' type='"+oneCourse.type+"' >",
                "<img src='"+oneCourse.pic+"' class='course_cover'/>",
                "<div class='course-title-container'>",
                    "<div>",
                    "<p class='course_title'>" + oneCourse.name + "</p>",
                    "<p class='course_data'>" + courseData + "</p>",
                    "</div>",
                "</div>",

            "</li>"
            );

        relativeUl.insertAdjacentHTML('beforeend', htmlStr.join(''));
    }


}

// 隐藏关注按钮
function hideFollow() {
    document.getElementById("focus_state").hidden="hidden"
}

// 显示关注按钮
function showFollow() {
    document.getElementById("focus_state").hidden=""
}

// 关注返回处理
function followBack(follow) {
    document.getElementById("focus_state").innerText=(JSON.parse(follow)?"已关注":"关注");
}

// 文字大小设置
function changeFontSize(size) {
    document.querySelector('.detail-content').style.fontSize = size + 'px';
}

function gotoAuthorCenter(view) {
    handNoteDetail.userCenter(view.getAttribute("value"));
}

function focusAuthor() {
    handNoteDetail.focusAuthor();
}

function shareWeChat() {
    handNoteDetail.shareWeChat();
}

function shareQQ() {
    handNoteDetail.shareQQ();
}

function shareTimeLine() {
    handNoteDetail.shareTimeLine();
}

function shareWeibo() {
    handNoteDetail.shareWeibo();
}

function clickLabel(label) {
    handNoteDetail.goHandNoteList(label.getAttribute('labelId'), label.getAttribute('labelName'));
}

function clickAD(ad) {
    handNoteDetail.recommendHandNote(ad.getAttribute('adId'));
}

// 后来新加需求，文章推荐相关课程，内有课程相关信息，不能使用广告系统的推荐了
function clickCourse(course) {
    handNoteDetail.recommendHandNote(course.getAttribute('typeId'), course.getAttribute('type'));
}

$(function(){
    initCodeCopy();
});
